/* ***********************************************************************************
Purpose:    Creates a list of SQL Objects with drop statements for droping back-up
			copies SQL objects created by ER/Studio Data Architect.
Author:     mstuewe
Date:       11/20/2013
************************************************************************************ */

--Shift + Ctrl + M will replace the names

-- Use this line without SQL Prompt: USE <DatabaseName, string,>
-- Use this line with SQL Prompt: USE <DatabaseName, string,$DBNAME$>
GO
DECLARE @Date AS varchar(10)

SELECT
    @date = '%' + CONVERT(varchar(2), MONTH(GETUTCDATE())) 
				+ ( CASE 
						WHEN DAY(GETUTCDATE()) < 10 THEN '0'
                        ELSE ''
                        END ) 
				+ CONVERT(varchar(2), DAY(GETUTCDATE())) 
				+ CONVERT(varchar(4), YEAR(GETUTCDATE())) + '%'

SELECT
    @date = '%' + CONVERT(varchar(2), MONTH(DATEADD(hh, 12,GETDATE()))) + ( CASE WHEN DAY(DATEADD(hh, 12,GETDATE())) < 10 THEN '0'
                                                                 ELSE ''
                                                            END ) + CONVERT(varchar(2), DAY(DATEADD(hh, 12,GETDATE()))) + CONVERT(varchar(4), YEAR(DATEADD(hh, 12,GETDATE()))) + '%'

SELECT
    'ALTER TABLE [' + s.name + '].[' + p.name + '] DROP CONSTRAINT  [' + o.name + ']' AS ItemToDrop
	,o.type

FROM
    sys.objects AS o
	JOIN sys.objects AS p ON o.parent_object_id = p.object_id
	JOIN sys.schemas AS s ON p.schema_id = s.schema_id
WHERE
    o.name LIKE @date
    AND o.type = 'F'

UNION ALL

SELECT
    'Drop Trigger [' + s.name + '].[' + o.name + ']' AS ItemToDrop
	,o.type
FROM
    sys.objects AS o
	JOIN sys.objects AS p ON o.parent_object_id = p.object_id
	JOIN sys.schemas AS s ON p.schema_id = s.schema_id
WHERE
    o.name LIKE @date
    AND o.type = 'TR'

UNION ALL

SELECT
    'drop table [' + s.name + '].[' + o.name + ']' AS ItemToDrop
	,o.type
FROM
    sys.objects AS o
	JOIN sys.schemas AS s ON o.schema_id = s.schema_id
WHERE
    o.name LIKE @date
    AND o.type  ='U'

UNION ALL

SELECT
    'drop proc [' + s.name + '].[' + o.name + ']' AS ItemToDrop
	,o.type
FROM
    sys.objects AS o
	JOIN sys.schemas AS s ON o.schema_id = s.schema_id
WHERE
    o.name LIKE @date
    AND o.type  ='P'
ORDER BY
	o.type									